/*
----------------------------------------------------------------------
  Script............: cdoAlertas.sql
  Compatibilidade...: SQL 2005
  ltima atualizao: 11/10/2012
----------------------------------------------------------------------
*/
SET NOCOUNT ON
GO
SET LANGUAGE English
GO

SET NOCOUNT ON
IF (left(@@Version,23)='Microsoft SQL Server 20' and left(@@Version,25)='Microsoft SQL Server 2000') and NOT EXISTS(SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'dbo.PTO_ALERTA') AND xtype = 'P')
BEGIN
   EXEC sp_configure 'lightweight pooling', 0
END;
GO
IF (left(@@Version,23)='Microsoft SQL Server 20' and left(@@Version,25)='Microsoft SQL Server 2000') and NOT EXISTS(SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'dbo.PTO_ALERTA') AND xtype = 'P')
BEGIN
   RECONFIGURE WITH OVERRIDE
END;
GO
IF (left(@@Version,23)='Microsoft SQL Server 20' and left(@@Version,25)='Microsoft SQL Server 2000') and NOT EXISTS(SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'dbo.PTO_ALERTA') AND xtype = 'P')
BEGIN
   EXEC sp_configure 'show advanced options', 1;
END;
GO
IF (left(@@Version,23)='Microsoft SQL Server 20' and left(@@Version,25)='Microsoft SQL Server 2000') and NOT EXISTS(SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'dbo.PTO_ALERTA') AND xtype = 'P')
BEGIN
   RECONFIGURE;
END;
GO
IF (left(@@Version,23)='Microsoft SQL Server 20' and left(@@Version,25)='Microsoft SQL Server 2000') and NOT EXISTS(SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'dbo.PTO_ALERTA') AND xtype = 'P')
BEGIN
   EXEC sp_configure 'Ole Automation Procedures', 1;
END;
GO
IF (left(@@Version,23)='Microsoft SQL Server 20' and left(@@Version,25)='Microsoft SQL Server 2000') and NOT EXISTS(SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'dbo.PTO_ALERTA') AND xtype = 'P')
BEGIN
   RECONFIGURE;
END;
GO

/*
   Alertas por usurio
*/
if not exists (select * from dbo.sysobjects where id = object_id(N'dbo.tbUsuAlert') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
begin
   CREATE TABLE [dbo].[tbUsuAlert] (
      [id_ref] BIGINT NOT NULL IDENTITY(1,1),
      [data] datetime NOT NULL,
      [id_usuario] int NOT NULL,
      [nome_usu] varchar(200) NOT NULL,
      [depart] varchar(100) NULL,
      [email] varchar(40) NULL,
      [alrtp_tipo_usu] tinyint NOT NULL,
      [alrtp_semana] tinyint NOT NULL,
      [descricao] varchar(200) NOT NULL,
      [tipo_reg] tinyint NOT NULL, --0 detalhe, 1 resumo
      [data_ocor] datetime NOT NULL,
      [m_intjr] BIGINT NOT NULL,
      [m_atrasos] BIGINT NOT NULL,
      [m_he_dia] BIGINT NOT NULL,
      [m_he_intervalo] BIGINT NOT NULL,
      [m_faltas] BIGINT NOT NULL,
      [conta_intjr] BIGINT NOT NULL,
      [conta_he_intervalo] BIGINT NOT NULL,
      [conta_faltas] BIGINT NOT NULL,
      [empresa] varchar(100) NULL,
      [id_empresa] int NULL,
      [m_he_lib] BIGINT NULL
   ) ON [PRIMARY];
   ALTER TABLE [dbo].[tbUsuAlert] WITH NOCHECK ADD CONSTRAINT [PK_tbUsuAlert] PRIMARY KEY CLUSTERED ([id_ref]) ON [PRIMARY];
   CREATE INDEX [IX_tbUsuAlert_data] ON [dbo].[tbUsuAlert]([data]) ON [PRIMARY];
   CREATE INDEX [IX_tbUsuAlert_tipo_reg] ON [dbo].[tbUsuAlert]([data],[id_usuario],[tipo_reg]) ON [PRIMARY];
end;
GO
--Atualizaes
IF NOT EXISTS(SELECT name FROM dbo.syscolumns WHERE id = object_id(N'dbo.tbUsuAlert') and name = 'depart')
BEGIN
   ALTER TABLE dbo.tbUsuAlert ADD [depart] varchar(100) NULL;
END;
GO
IF NOT EXISTS(SELECT name FROM dbo.syscolumns WHERE id = object_id(N'dbo.tbUsuAlert') and name = 'empresa')
BEGIN
    ALTER TABLE dbo.tbUsuAlert ADD [empresa] varchar(100) NULL;
   ALTER TABLE dbo.tbUsuAlert ADD [id_empresa] int NULL;
END;
GO
IF NOT EXISTS(SELECT name FROM dbo.syscolumns WHERE id = object_id(N'dbo.tbUsuAlert') and name = 'm_he_lib')
BEGIN
   ALTER TABLE dbo.tbUsuAlert ADD [m_he_lib] BIGINT NULL;
END;
GO

IF EXISTS(SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'dbo.P_CMTOH1') AND xtype = 'P') BEGIN DROP PROCEDURE dbo.P_CMTOH1; END;
GO
CREATE PROCEDURE dbo.P_CMTOH1(@minutos bigint, @marc varchar(20) output) WITH ENCRYPTION AS
BEGIN
   declare @hor bigint;
   declare @min bigint;
   select @marc = '0:00', @hor = 0, @min = 0;
   select @hor = @minutos / 60;
   select @min = @minutos - (@hor * 60);
   select @marc = ltrim(str(@hor));
   select @marc = @marc + ':' + right('00'+ltrim(str(@min)),2);
   if @marc = '0:00'
      select @marc = '-';
END;
GO

IF EXISTS(SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'dbo.PTO_ALERTA') AND xtype = 'P') BEGIN DROP PROCEDURE dbo.PTO_ALERTA END;
GO
CREATE PROCEDURE dbo.PTO_ALERTA(@par1 VARCHAR(1000), @par2 VARCHAR(1000), @par3 varchar(MAX)) WITH ENCRYPTION AS
BEGIN
   SET NOCOUNT ON;
   SET LANGUAGE English;
   DECLARE @locReturnCode       INT;
   DECLARE @locCOMObject        INT;
   DECLARE @locMsgError         VARCHAR(1000);
   DECLARE @alerta              BIT;
   DECLARE @locnmServidorEmail    VARCHAR(50);
   DECLARE @locnmEmailRemetente   VARCHAR(80);
   DECLARE @locinAutenticacao     VARCHAR(1);
   DECLARE @locnmUsuario          VARCHAR(80);
   DECLARE @locdsSenha            VARCHAR(30);
   DECLARE @locnrPortaSMTP        INT;
   DECLARE @ssl                   BIT;
   DECLARE @meio                  INT; DECLARE @i INT;
   DECLARE @aux                   VARCHAR(100);
   DECLARE @rst                   VARCHAR(100);

   -- Obtm os parmetros utilizados para o envio do e-mail
   select @alerta=0;
   SELECT TOP 1 @alerta=alerta, @locnmServidorEmail=env_servidor,
          @locnmEmailRemetente=env_remetente,
          @locinAutenticacao=(case when env_autenticacao=1 then 'S' else 'N' end),
          @locnmUsuario=env_usuario,
          @locdsSenha=env_senha,
          @locnrPortaSMTP=env_porta,
          @ssl=env_ssl FROM tbPtoAlerta;

   if isnull(@alerta,0)=0 begin
      RETURN (0)
   end;

   if ltrim(@locdsSenha) <> ''
   begin
      select @meio=Len(@locdsSenha) / 2;
      If (@meio*2) < Len(@locdsSenha) begin select @meio=@meio+1; end;
      select @aux='', @i=1;
      while (@i<=@meio)
      begin
         select @aux = @aux + Substring(@locdsSenha, @i, 1);
         if @meio + @i <= Len(@locdsSenha) begin select @aux = @aux + Substring(@locdsSenha, @meio + @i, 1); end;
         select @i=@i+1;
      end;
      select @rst='', @i=1;
      while (@i<=Len(@aux))
      begin
         select @rst = @rst + Char(Convert(int,Substring(@aux, @i, 3)));
         select @i=@i+3;
      end;
      select @locdsSenha=@rst;
   end;

   -- Instancia objeto CDO.Message
   EXEC @locReturnCode = sp_OACreate 'CDO.MESSAGE', @locCOMObject OUT
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0021 - No foi possvel instanciar o objeto CDO.Message'
         GOTO TratamentoErro
      END

   -- Configura a forma de enviar o e-mail (2 = atravs da porta SMTP)
   EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'Configuration.fields ("http://schemas.microsoft.com/cdo/configuration/sendusing").Value', '2'
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0022 - No foi possvel configurar a propriedade: SendUsing'
         GOTO TratamentoErro
      END

   -- Configura o nome do servidor SMTP
   EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'Configuration.fields("http://schemas.microsoft.com/cdo/configuration/smtpserver").Value', @locnmServidorEmail
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0023 - No foi possvel configurar a propriedade: SMTPServer'
         GOTO TratamentoErro
      END

   -- Replace 25 by the PORT SMTP Server.
   EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'Configuration.Fields ("http://schemas.microsoft.com/cdo/configuration/smtpserverport")', @locnrPortaSMTP
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0024 - No foi possvel configurar a propriedade: SMTPServerPort'
         GOTO TratamentoErro
      END

   -- Configura a forma de autenticao do servidor STMP (1 = clear text authentication)
   IF @locinAutenticacao = 'S'
      BEGIN
         EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'Configuration.fields("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate").Value', '1'
         IF (@@ERROR | @locReturnCode <> 0)
            BEGIN
               SET @locMsgError = 'M0025 - No foi possvel configurar a propriedade: SMTPAthenticate'
               GOTO TratamentoErro
            END

         -- Configura o usurio para a autenticao SMTP
         EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'Configuration.fields("http://schemas.microsoft.com/cdo/configuration/sendusername").Value', @locnmUsuario
         IF (@@ERROR | @locReturnCode <> 0)
            BEGIN
               SET @locMsgError = 'M0026 - No foi possvel configurar a propriedade: SendUserName'
               GOTO TratamentoErro
            END

         -- Configura a senha para a autenticao SMTP
         EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'Configuration.fields("http://schemas.microsoft.com/cdo/configuration/sendpassword").Value', @locdsSenha
         IF (@@ERROR | @locReturnCode <> 0)
            BEGIN
               SET @locMsgError = 'M0027 - No foi possvel configurar a propriedade: SendPassword'
               GOTO TratamentoErro
            END
      END

   --Iniciar TLS/SSL
   if @ssl=1 begin
      EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'Configuration.fields("http://schemas.microsoft.com/cdo/configuration/smtpusessl").Value', True
      IF (@@ERROR | @locReturnCode <> 0)
         BEGIN
            SET @locMsgError = 'Iniciar TSL/SSL '
            GOTO TratamentoErro
         END
   end;
   --EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'Configuration.fields("http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout").Value', 60

   -- Salva as configuraes do objeto
   EXEC @locReturnCode = sp_OAMethod @locCOMObject, 'CONFIGURATION.FIELDS.UPDATE', NULL
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0028 - No foi salvar as configuraes do objeto CDO.Message'
         GOTO TratamentoErro
      END

   -- Configura a propriedade: TO
   EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'TO', @par1
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0029 - No foi possvel configurar a propriedade TO do objeto CDO.Message'
         GOTO TratamentoErro
      END

   -- Configura a propriedade: FROM
   EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'FROM', @locnmEmailRemetente
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0030 - No foi possvel configurar a propriedade FROM do objeto CDO.Message'
         GOTO TratamentoErro
      END

   -- Configura a propriedade: SUBJECT
   EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'SUBJECT', @par2
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0031 - No foi possvel configurar a propriedade SUBJECT do objeto CDO.Message'
         GOTO TratamentoErro
      END

   -- Configura a propriedade: TEXTBODY ou HTMLBODY (caso seja HTML)
   EXEC @locReturnCode = sp_OASetProperty @locCOMObject, 'HTMLBODY', @par3
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0032 - No foi possvel configurar a propriedade TEXTBODY do objeto CDO.Message'
         GOTO TratamentoErro
      END

   -- Envia o e-mail
   EXEC @locReturnCode = sp_OAMethod @locCOMObject, 'SEND', NULL
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0034 - No foi possvel enviar o e-mail atravs do objeto CDO.Message'
         GOTO TratamentoErro
      END

   -- Destri a instncia do objeto
   EXEC @locReturnCode = sp_OADestroy @locCOMObject
   IF (@@ERROR | @locReturnCode <> 0)
      BEGIN
         SET @locMsgError = 'M0035 - No foi possvel elimianr a instncia do objeto CDO.Message'
         GOTO TratamentoErro
      END

   RETURN (0)


TratamentoErro:
   DECLARE @locSourceError      AS VARCHAR(1000)
   DECLARE @locDescriptionError AS VARCHAR(1000)

   -- Compe a mensagem com o cdigo original do erro
   SET @locMsgError = @locMsgError + ' (Erro: ' + CAST(@locReturnCode AS VARCHAR(20))

   -- Obtm a mensagem original de erro
   EXEC @locReturnCode = sp_OAGetErrorInfo NULL, @locSourceError OUT, @locDescriptionError OUT
   IF @locReturnCode = 0
      BEGIN
         IF COALESCE(@locSourceError, '') <> ''
            SET @locMsgError = @locMsgError + ': ' + @locSourceError + ' - ' + @locDescriptionError
         ELSE
            SET @locMsgError = @locMsgError + ': ' + @locDescriptionError
      END

   SET @locMsgError = @locMsgError + ')'

   RAISERROR (@locMsgError, 16, 1)

   RETURN (-1)
END;
GO

IF EXISTS(SELECT * FROM sysobjects WHERE id = OBJECT_ID(N'dbo.PROC_ALERTA_PTO') AND xtype = 'P') BEGIN DROP PROCEDURE dbo.PROC_ALERTA_PTO; END;
GO
CREATE PROCEDURE dbo.PROC_ALERTA_PTO(@id_usuario int) WITH ENCRYPTION AS
BEGIN
   SET NOCOUNT ON;
   SET LANGUAGE English;
   declare @data datetime, @wdia tinyint, @psi int, @s_ini datetime, @s_fim datetime;
   declare @achou bit; declare @id_ini bigint; declare @id_fim bigint; declare @id_atual bigint;
   declare @id_usuario_a int; declare @nome_usu varchar(180); declare @alrtp_tipo_usu tinyint;
   declare @descricao varchar(100); declare @tipo_reg tinyint; declare @data_ocor datetime; declare @depart varchar(100);
   declare @m_intjr BIGINT; declare @m_atrasos BIGINT; declare @m_he_dia BIGINT; declare @m_he_lib BIGINT; declare @m_he_intervalo BIGINT;
   declare @m_faltas BIGINT; declare @conta_intjr BIGINT; declare @conta_he_intervalo BIGINT; declare @alrtp_semana tinyint;
   declare @todosf bit;
   declare @conta_faltas BIGINT; declare @conta_linha int; declare @conta_pag int; declare @linha_atu int; declare @pag_atu int;
   declare @msg varchar(MAX); declare @stl varchar(1000); declare @tit varchar(1000); declare @tit2 varchar(1000); declare @leg varchar(2000);
   declare @cab1 varchar(1000); declare @cab2 varchar(1000); declare @cab3 varchar(1000); declare @cabt varchar(1000); declare @cabt2 varchar(1000); declare @rdp varchar(1000);
   declare @alerta BIT; declare @interjor BIT; declare @min_interjor INT; declare @he_intervalo BIT;
   declare @min_intervalo INT; declare @he_dia BIT; declare @min_he_dia INT; declare @atraso_dia BIT;
   declare @min_atraso_dia INT; declare @falta_dia BIT; declare @c varchar(100) declare @marc varchar(20);
   declare @mx_pg int; declare @sistema varchar(100); declare @email varchar(40);
   declare @empresa varchar(100); declare @id_empresa int; declare @id_empresa_aux int;
   declare @tem_lib bit;

   select @alerta=0;
   SELECT TOP 1 @alerta=alerta, @interjor=interjor, @min_interjor=min_interjor, @he_intervalo=he_intervalo,
         @min_intervalo=min_intervalo, @he_dia=he_dia, @min_he_dia=min_he_dia, @atraso_dia=atraso_dia,
         @min_atraso_dia=min_atraso_dia, @falta_dia=falta_dia, @todosf=isnull(todosf,0) FROM tbPtoAlerta;

   if @alerta=0 begin
      RETURN(0);
   end;

   select @data=convert(datetime,convert(varchar,getdate(),101));
   select @wdia = DATEPART(dw,@data);
   select @psi=((DATEPART(dw,@data)-1)*(-1))-7;
   select @s_ini = dateadd(d,@psi,@data);
   select @s_fim = dateadd(d,6,@s_ini);
   select @tem_lib=0;
   if exists(SELECT TOP 1 id_cliente FROM tbLicencas WHERE sistema = 'pwAcesso')
      AND exists(SELECT TOP 1 id_pass FROM tbLibAcesso) begin
      select @tem_lib=1;
   end;

   if isnull(@id_usuario,0)=0 begin
      exec PROC_REAP_PTO 1;
   end;

   DELETE FROM tbUsuAlert;

   select @achou=0;
  -- if @id_usuario>0 or exists(SELECT TOP 1 id_usuario FROM tbUsuarios WHERE alrtp_semana=@wdia)
   if @achou=0
   begin

      select @id_usuario_a=0,@achou=1;
      while (@achou=1) begin
         select @achou=0;
         SELECT TOP 1 @achou=1, @id_usuario_a=id_usuario FROM tbUsuarios WHERE id_usuario>@id_usuario_a AND alrtp_tipo_usu=1 ORDER BY id_usuario;
         if @achou=1 begin
            INSERT INTO tbUsuAlert( data, id_usuario, nome_usu, email, alrtp_tipo_usu, alrtp_semana, tipo_reg, descricao, depart, data_ocor,
               m_intjr, m_atrasos, m_he_dia, m_he_lib, m_he_intervalo, m_faltas, conta_intjr, conta_he_intervalo, conta_faltas, id_empresa, empresa)
            SELECT @s_fim, u.id_usuario, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', u.email, isnull(u.alrtp_tipo_usu,0), isnull(u.alrtp_semana,0), 0,
               ltrim(str((case when len(isnull(p.codass,''))=0 then p.cracha else p.codass end),38,0)) + ' - ' + ltrim(p.nome), isnull(dp.descricao,'') as desc_depart, e.data,
               (CASE WHEN isnull(e.alrt_interjor,0)=1 THEN isnull(e.m_intjr,0) ELSE 0 END),
               (CASE WHEN isnull(e.alrt_atraso_dia,0)=1 THEN isnull(e.m_atrasos,0) ELSE 0 END),
               (CASE WHEN isnull(e.alrt_he_dia,0)=1 THEN isnull(e.m_he_dia,0) ELSE 0 END),
               (CASE WHEN isnull(e.alrt_he_dia,0)=1 AND
                  EXISTS(SELECT lib.id_pass FROM tbLibAcesso lib WHERE lib.id_pass=e.id_pass AND e.data BETWEEN convert(datetime,convert(varchar,lib.data,101)) AND lib.dataf)
               THEN
                  isnull((SELECT TOP 1 datediff(mi,lib.data,dateadd(mi,1,lib.dataf)) FROM tbLibAcesso lib WHERE lib.id_pass=e.id_pass AND e.data BETWEEN convert(datetime,convert(varchar,lib.data,101)) AND lib.dataf),0)
               ELSE 0 END),
               (CASE WHEN isnull(e.alrt_he_intv,0)=1 THEN isnull(e.m_he_intervalo,0) ELSE 0 END),
               isnull(e.m_faltas,0), 0,0,0, emp.id_empresa, emp.cnpj+' - '+ltrim(isnull(emp.nome_fantasia,'')) as empresa
            FROM tbUsuarios u
            INNER JOIN tbPtoEstat e ON e.alerta_dia=1 AND e.data BETWEEN @s_ini AND @s_fim
            INNER JOIN tbPass p ON p.id_pass = e.id_pass
            INNER JOIN tbEmpresas emp ON p.id_empresa = emp.id_empresa
            LEFT JOIN tbDepart dp ON p.id_depart = dp.id_depart
            WHERE u.id_usuario=@id_usuario_a AND (u.nivel_p=1 or u.geral=1 or p.id_empresa=u.id_empresa)
               AND (
                  (NOT EXISTS(SELECT TOP 1 g1.id_agrupamento FROM tbUsuGrupos g1 WHERE g1.id_usuario=u.id_usuario))
               OR (
                  EXISTS(SELECT TOP 1 g2.id_agrupamento FROM tbUsuGrupos g2 WHERE g2.id_usuario=u.id_usuario AND g2.id_agrupamento=isnull(p.id_agrupamento,0))
                  )
               )
            ORDER BY empresa, emp.id_empresa, dp.descricao, dp.id_depart, p.nome, e.data;

            UPDATE tbUsuAlert SET m_he_lib = m_he_dia WHERE isnull(m_he_lib,0) > isnull(m_he_dia,0);

            INSERT INTO tbUsuAlert( data, id_usuario, nome_usu, email, alrtp_tipo_usu, alrtp_semana, tipo_reg, descricao, data_ocor,
               m_intjr, m_atrasos, m_he_dia, m_he_lib, m_he_intervalo, m_faltas, conta_intjr, conta_he_intervalo, conta_faltas)
            SELECT @s_fim, u.id_usuario, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', u.email, isnull(u.alrtp_tipo_usu,0), isnull(u.alrtp_semana,0), 1, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', @s_fim,
               SUM(isnull(e.m_intjr,0)), SUM(isnull(e.m_atrasos,0)), SUM(isnull(e.m_he_dia,0)), SUM(isnull(e.m_he_lib,0)), SUM(isnull(e.m_he_intervalo,0)), SUM(isnull(e.m_faltas,0)),
               SUM((CASE WHEN e.m_intjr>0 THEN 1 ELSE 0 END)),SUM((CASE WHEN e.m_he_intervalo>0 THEN 1 ELSE 0 END)),SUM((CASE WHEN e.m_faltas>0 THEN 1 ELSE 0 END))
            FROM tbUsuarios u LEFT JOIN tbUsuAlert e ON e.data=@s_fim AND e.id_usuario = u.id_usuario AND e.tipo_reg=0
            WHERE u.id_usuario=@id_usuario_a
            GROUP BY u.id_usuario, u.nome, u.email, u.alrtp_area, u.alrtp_tipo_usu, u.alrtp_semana
         end;--@achou=1
      end; --while operadores

      if @todosf=0
      begin
         DELETE FROM tbUsuAlert WHERE isnull(m_intjr,0)=0 AND
                                      isnull(m_atrasos,0)=0 AND
                                      isnull(m_he_dia,0)=0 AND
                                      isnull(m_he_intervalo,0)=0 AND
                                      isnull(m_faltas,0) = 0 AND
                                      isnull(conta_intjr,0)=0 AND
                                      isnull(conta_he_intervalo,0)=0 AND
                                      isnull(conta_faltas,0)=0;
      end;

      select @id_usuario_a=0,@achou=1;
      while (@achou=1) begin
         select @achou=0;
         SELECT TOP 1 @achou=1, @id_usuario_a=id_usuario FROM tbUsuarios WHERE id_usuario>@id_usuario_a AND alrtp_tipo_usu=2 ORDER BY id_usuario;
         if @achou=1 begin
            INSERT INTO tbUsuAlert( data, id_usuario, nome_usu, email, alrtp_tipo_usu, alrtp_semana, tipo_reg, descricao, depart, data_ocor,
               m_intjr, m_atrasos, m_he_dia, m_he_lib, m_he_intervalo, m_faltas, conta_intjr, conta_he_intervalo, conta_faltas, id_empresa, empresa)
            SELECT @s_fim, u.id_usuario, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', u.email, isnull(u.alrtp_tipo_usu,0),
               isnull(u.alrtp_semana,0), 0, ltrim(str((case when len(isnull(p.codass,''))=0 then p.cracha else p.codass end),38,0)) + ' - ' + ltrim(p.nome), isnull(dp.descricao,'') as desc_depart, e.data,
               (CASE WHEN isnull(e.alrt_interjor,0)=1 THEN isnull(e.m_intjr,0) ELSE 0 END),
               (CASE WHEN isnull(e.alrt_atraso_dia,0)=1 THEN isnull(e.m_atrasos,0) ELSE 0 END),
               (CASE WHEN isnull(e.alrt_he_dia,0)=1 THEN isnull(e.m_he_dia,0) ELSE 0 END),
               (CASE WHEN isnull(e.alrt_he_dia,0)=1 AND
                  EXISTS(SELECT lib.id_pass FROM tbLibAcesso lib WHERE lib.id_pass=e.id_pass AND e.data BETWEEN convert(datetime,convert(varchar,lib.data,101)) AND lib.dataf)
               THEN
                  isnull((SELECT TOP 1 datediff(mi,lib.data,dateadd(mi,1,lib.dataf)) FROM tbLibAcesso lib WHERE lib.id_pass=e.id_pass AND e.data BETWEEN convert(datetime,convert(varchar,lib.data,101)) AND lib.dataf),0)
               ELSE 0 END),
               (CASE WHEN isnull(e.alrt_he_intv,0)=1 THEN isnull(e.m_he_intervalo,0) ELSE 0 END),
               isnull(e.m_faltas,0), 0,0,0, emp.id_empresa, emp.cnpj+' - '+ltrim(isnull(emp.nome_fantasia,'')) as empresa
            FROM tbUsuarios u
            INNER JOIN tbPtoEstat e ON e.alerta_dia=1 AND e.data BETWEEN @s_ini AND @s_fim
            INNER JOIN tbPass p ON p.id_pass = e.id_pass
            INNER JOIN tbEmpresas emp ON p.id_empresa = emp.id_empresa
            LEFT JOIN tbDepart dp ON p.id_depart = dp.id_depart
            WHERE u.id_usuario=@id_usuario_a AND (u.nivel_p=1 or u.geral=1 or p.id_empresa=u.id_empresa)
               AND (
                  (NOT EXISTS(SELECT TOP 1 g1.id_agrupamento FROM tbUsuGrupos g1 WHERE g1.id_usuario=u.id_usuario))
               OR (
                  EXISTS(SELECT TOP 1 g2.id_agrupamento FROM tbUsuGrupos g2 WHERE g2.id_usuario=u.id_usuario AND g2.id_agrupamento=isnull(p.id_agrupamento,0))
                  )
               )
            ORDER BY empresa, emp.id_empresa, dp.descricao, dp.id_depart, p.nome, e.data

            UPDATE tbUsuAlert SET m_he_lib = m_he_dia WHERE isnull(m_he_lib,0) > isnull(m_he_dia,0);

            INSERT INTO tbUsuAlert( data, id_usuario, nome_usu, email, alrtp_tipo_usu, alrtp_semana, tipo_reg, descricao, data_ocor,
               m_intjr, m_atrasos, m_he_dia, m_he_lib, m_he_intervalo, m_faltas, conta_intjr, conta_he_intervalo, conta_faltas)
            SELECT @s_fim, u.id_usuario, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', u.email, isnull(u.alrtp_tipo_usu,0), isnull(u.alrtp_semana,0), 1, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', @s_fim,
               SUM(isnull(e.m_intjr,0)), SUM(isnull(e.m_atrasos,0)), SUM(isnull(e.m_he_dia,0)), SUM(isnull(e.m_he_lib,0)), SUM(isnull(e.m_he_intervalo,0)), SUM(isnull(e.m_faltas,0)),
               SUM((CASE WHEN e.m_intjr>0 THEN 1 ELSE 0 END)),SUM((CASE WHEN e.m_he_intervalo>0 THEN 1 ELSE 0 END)),SUM((CASE WHEN e.m_faltas>0 THEN 1 ELSE 0 END))
            FROM tbUsuarios u LEFT JOIN tbUsuAlert e ON e.data=@s_fim AND e.id_usuario = u.id_usuario AND e.tipo_reg=0
            WHERE u.id_usuario=@id_usuario_a
            GROUP BY u.id_usuario, u.nome, u.email, u.alrtp_area, u.alrtp_tipo_usu, u.alrtp_semana
         end;--@achou=1
      end; --while supervisores

      select @id_usuario_a=0,@achou=1;
      while (@achou=1) begin
         select @achou=0;
         SELECT TOP 1 @achou=1, @id_usuario_a=id_usuario FROM tbUsuarios WHERE id_usuario>@id_usuario_a AND alrtp_tipo_usu=3 ORDER BY id_usuario;
         if @achou=1 begin

            INSERT INTO tbUsuAlert( data, id_usuario, nome_usu, email, alrtp_tipo_usu, alrtp_semana, tipo_reg, descricao, data_ocor,
               m_intjr, m_atrasos, m_he_dia, m_he_lib, m_he_intervalo, m_faltas, conta_intjr, conta_he_intervalo, conta_faltas)
            SELECT @s_fim, u.id_usuario, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', u.email, isnull(u.alrtp_tipo_usu,0), isnull(u.alrtp_semana,0), 0, isnull(e.nome_usu,''), @s_fim,
               SUM(isnull(e.m_intjr,0)), SUM(isnull(e.m_atrasos,0)), SUM(isnull(e.m_he_dia,0)), SUM(isnull(e.m_he_lib,0)), SUM(isnull(e.m_he_intervalo,0)), SUM(isnull(e.m_faltas,0)),
               SUM(isnull(e.conta_intjr,0)),SUM(isnull(e.conta_he_intervalo,0)),SUM(isnull(e.conta_faltas,0))
            FROM tbUsuarios u INNER JOIN tbUsuAlert e ON e.data=@s_fim AND e.id_usuario IN (SELECT v.id_usuario_vin FROM tbAlertasUsu v WHERE v.id_usuario_ref=u.id_usuario) AND e.tipo_reg=1 AND e.alrtp_tipo_usu=2
            WHERE u.id_usuario=@id_usuario_a AND (e.m_intjr>0  OR e.m_atrasos > 0 OR e.m_he_dia > 0 OR e.m_he_intervalo > 0 OR e.m_faltas > 0)
            GROUP BY u.id_usuario, u.nome, u.email, u.alrtp_area, u.alrtp_tipo_usu, u.alrtp_semana, e.nome_usu
            ORDER BY u.id_usuario, e.nome_usu

            INSERT INTO tbUsuAlert( data, id_usuario, nome_usu, email, alrtp_tipo_usu, alrtp_semana, tipo_reg, descricao, data_ocor,
               m_intjr, m_atrasos, m_he_dia, m_he_lib, m_he_intervalo, m_faltas, conta_intjr, conta_he_intervalo, conta_faltas)
            SELECT @s_fim, u.id_usuario, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', u.email, isnull(u.alrtp_tipo_usu,0), isnull(u.alrtp_semana,0), 1, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', @s_fim,
               SUM(isnull(e.m_intjr,0)), SUM(isnull(e.m_atrasos,0)), SUM(isnull(e.m_he_dia,0)), SUM(isnull(e.m_he_lib,0)), SUM(isnull(e.m_he_intervalo,0)), SUM(isnull(e.m_faltas,0)),
               SUM(isnull(e.conta_intjr,0)),SUM(isnull(e.conta_he_intervalo,0)),SUM(isnull(e.conta_faltas,0))
            FROM tbUsuarios u LEFT JOIN tbUsuAlert e ON e.data=@s_fim AND e.id_usuario IN (SELECT v.id_usuario_vin FROM tbAlertasUsu v WHERE v.id_usuario_ref=u.id_usuario) AND e.tipo_reg=1 AND e.alrtp_tipo_usu=2
            WHERE u.id_usuario=@id_usuario_a
            GROUP BY u.id_usuario, u.nome, u.email, u.alrtp_area, u.alrtp_tipo_usu, u.alrtp_semana
         end;--@achou=1
      end;--while gerentes

      select @id_usuario_a=0,@achou=1;
      while (@achou=1) begin
         select @achou=0;
         SELECT TOP 1 @achou=1, @id_usuario_a=id_usuario FROM tbUsuarios WHERE id_usuario>@id_usuario_a AND alrtp_tipo_usu=4 ORDER BY id_usuario;
         if @achou=1 begin
            INSERT INTO tbUsuAlert( data, id_usuario, nome_usu, email, alrtp_tipo_usu, alrtp_semana, tipo_reg, descricao, data_ocor,
               m_intjr, m_atrasos, m_he_dia, m_he_lib, m_he_intervalo, m_faltas, conta_intjr, conta_he_intervalo, conta_faltas)
            SELECT @s_fim, u.id_usuario, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', u.email, isnull(u.alrtp_tipo_usu,0), isnull(u.alrtp_semana,0), 0, isnull(e.nome_usu,''), @s_fim,
               SUM(isnull(e.m_intjr,0)), SUM(isnull(e.m_atrasos,0)), SUM(isnull(e.m_he_dia,0)), SUM(isnull(e.m_he_lib,0)), SUM(isnull(e.m_he_intervalo,0)), SUM(isnull(e.m_faltas,0)),
               SUM(isnull(e.conta_intjr,0)),SUM(isnull(e.conta_he_intervalo,0)),SUM(isnull(e.conta_faltas,0))
            FROM tbUsuarios u INNER JOIN tbUsuAlert e ON e.data=@s_fim AND e.id_usuario IN (SELECT v.id_usuario_vin FROM tbAlertasUsu v WHERE v.id_usuario_ref=u.id_usuario) AND e.tipo_reg=1 AND e.alrtp_tipo_usu=3
            WHERE u.id_usuario=@id_usuario_a AND (e.m_intjr>0  OR e.m_atrasos > 0 OR e.m_he_dia > 0 OR e.m_he_intervalo > 0 OR e.m_faltas > 0)
            GROUP BY u.id_usuario, u.nome, u.email, u.alrtp_area, u.alrtp_tipo_usu, u.alrtp_semana, e.nome_usu
            ORDER BY u.id_usuario, e.nome_usu

            INSERT INTO tbUsuAlert( data, id_usuario, nome_usu, email, alrtp_tipo_usu, alrtp_semana, tipo_reg, descricao, data_ocor,
               m_intjr, m_atrasos, m_he_dia, m_he_lib, m_he_intervalo, m_faltas, conta_intjr, conta_he_intervalo, conta_faltas)
            SELECT @s_fim, u.id_usuario, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', u.email, isnull(u.alrtp_tipo_usu,0), isnull(u.alrtp_semana,0), 1, ltrim(u.nome) + ' [ ' + ltrim(isnull(u.alrtp_area,'')) + ' ]', @s_fim,
               SUM(isnull(e.m_intjr,0)), SUM(isnull(e.m_atrasos,0)), SUM(isnull(e.m_he_dia,0)), SUM(isnull(e.m_he_lib,0)), SUM(isnull(e.m_he_intervalo,0)), SUM(isnull(e.m_faltas,0)),
               SUM(isnull(e.conta_intjr,0)),SUM(isnull(e.conta_he_intervalo,0)),SUM(isnull(e.conta_faltas,0))
            FROM tbUsuarios u LEFT JOIN tbUsuAlert e ON e.data=@s_fim AND e.id_usuario IN (SELECT v.id_usuario_vin FROM tbAlertasUsu v WHERE v.id_usuario_ref=u.id_usuario) AND e.tipo_reg=1 AND e.alrtp_tipo_usu=3
            WHERE u.id_usuario=@id_usuario_a
            GROUP BY u.id_usuario, u.nome, u.email, u.alrtp_area, u.alrtp_tipo_usu, u.alrtp_semana
         end;--@achou=1
      end;--while diretores


      --CSS
      select @stl = '<style type="text/css"> ';
      select @stl = @stl + 'body {font-family: Verdana,Arial; font-size: 11px;}';
      select @stl = @stl + 'table.stl {border-collapse: collapse; border-spacing: 0px}';
      select @stl = @stl + 'table.stl td {border: 1px solid #2F4F4F; font-family: Verdana,Arial; font-size: 10px; text-align: center}';
      select @stl = @stl + '</style>';

      --Ttulos, legenda e cabealhos
      select @tit='Alerta de ponto [' + convert(varchar,@s_ini,103) + '  ' + convert(varchar,@s_fim,103) + ']';
      select @tit2='Alerta automtico de ponto';
      select @sistema='Pw-Ponto verso ';
      SELECT @sistema=@sistema+ltrim(str(AtualPto/100.0,6,2)) FROM tbVersao;

      select @leg = '<div><span><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;">Descrio dos campos de alerta:</strong></span></div>';
      select @leg = @leg + '<div><table width="500" class="stl" cellpadding="3" cellspacing="3">';
      select @leg = @leg + '<tr><td><strong>Campo</strong></td><td><strong>Descrio</strong></td></tr>';

      select @cab1 = '<tr><td><strong>Departamento</strong></td><td><strong>Funcionrio</strong></td><td><strong>Dia</strong></td>';
      select @cab2 = '<tr><td><strong>Supervisor e rea</strong></td>';
      select @cab3 = '<tr><td><strong>Gerente e rea</strong></td>';
      select @cabt = '<tr>';
      select @cabt2 = '<tr>';

      if @he_dia=1 begin
         select @c='Horas extras';

         if @min_he_dia<60 begin
            select @marc=ltrim(str(@min_he_dia)) + ' minuto(s)';
         end else begin
            exec P_CMTOH1 @min_he_dia, @marc output;
            select @marc=@marc+' hora(s)';
         end;
         if @min_he_dia<60
            select @leg = @leg + '<tr><td><strong>'+@c+'</strong></td><td>Ocorrncia de H.E. no dia</td></tr>';
         else
            select @leg = @leg + '<tr><td><strong>'+@c+'</strong></td><td>Ocorrncia de H.E. superiores a ' + @marc + ' no dia </td></tr>';
         select @cab1 = @cab1 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cab2 = @cab2 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cab3 = @cab3 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cabt = @cabt + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cabt2 = @cabt2 + '<td><strong>'+@c+'</strong><br>(horas)</td>';

         if @tem_lib=1 begin
            select @c='Autorizadas';

            if @min_he_dia<60 begin
               select @marc=ltrim(str(@min_he_dia)) + ' minuto(s)';
            end else begin
               exec P_CMTOH1 @min_he_dia, @marc output;
               select @marc=@marc+' hora(s)';
            end;
            select @leg = @leg + '<tr><td><strong>'+@c+'</strong></td><td>Ocorrncia de H.E. com liberao de acesso no dia</td></tr>';
            select @cab1 = @cab1 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
            select @cab2 = @cab2 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
            select @cab3 = @cab3 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
            select @cabt = @cabt + '<td><strong>'+@c+'</strong><br>(horas)</td>';
            select @cabt2 = @cabt2 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         end;
      end;
      if @he_intervalo=1 begin
         select @c='HE no interv.';

         if @min_intervalo<60 begin
            select @marc=ltrim(str(@min_intervalo)) + ' minuto(s)';
         end else begin
            exec P_CMTOH1 @min_intervalo, @marc output;
            select @marc=@marc+' hora(s)';
         end;
         select @leg = @leg + '<tr><td><strong>'+@c+'</strong></td><td>Ocorrncia de H.E. superior a ' + @marc + ' no intervalo de almoo/janta</td></tr>';
         select @cab1 = @cab1 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cab2 = @cab2 + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
         select @cab3 = @cab3 + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
         select @cabt = @cabt + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
         select @cabt2 = @cabt2 + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
      end;
      if @falta_dia=1 begin
         select @c='Faltas';

         select @leg = @leg + '<tr><td><strong>'+@c+'</strong></td><td>Ocorrncia de faltas dentro do perodo</td></tr>';
         select @cab1 = @cab1 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cab2 = @cab2 + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
         select @cab3 = @cab3 + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
         select @cabt = @cabt + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
         select @cabt2 = @cabt2 + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
      end;
      if @atraso_dia=1 begin
         select @c='Atrasos';

         if @min_atraso_dia<60 begin
            select @marc=ltrim(str(@min_atraso_dia)) + ' minuto(s)';
         end else begin
            exec P_CMTOH1 @min_atraso_dia, @marc output;
            select @marc=@marc+' hora(s)';
         end;
         if @min_atraso_dia=0
            select @leg = @leg + '<tr><td><strong>'+@c+'</strong></td><td>Ocorrncia de atrasos no dia</td></tr>';
         else
            select @leg = @leg + '<tr><td><strong>'+@c+'</strong></td><td>Ocorrncia de atrasos superiores a ' + @marc + ' no dia</td></tr>';
         select @cab1 = @cab1 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cab2 = @cab2 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cab3 = @cab3 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cabt = @cabt + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cabt2 = @cabt2 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
      end;
      if @interjor=1 begin
         select @c='Interjornada';

         if @min_interjor<60 begin
            select @marc=ltrim(str(@min_interjor)) + ' minuto(s)';
         end else begin
            exec P_CMTOH1 @min_interjor, @marc output;
            select @marc=@marc+' hora(s)';
         end;
         select @leg = @leg + '<tr><td><strong>'+@c+'</strong></td><td align="left">Interjornada inferior a ' + @marc + '</td></tr>';
         select @cab1 = @cab1 + '<td><strong>'+@c+'</strong><br>(horas)</td>';
         select @cab2 = @cab2 + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
         select @cab3 = @cab3 + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
         select @cabt = @cabt + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
         select @cabt2 = @cabt2 + '<td><strong>'+@c+'</strong><br>(qtd.)</td>';
      end;
      select @cab1 = @cab1 + '</tr>';
      select @cab2 = @cab2 + '</tr>';
      select @cab3 = @cab3 + '</tr>';
      select @cabt = @cabt + '</tr>';
      select @cabt2 = @cabt2 + '</tr>';

      select @leg = @leg + '</table></div><br>';

      select @rdp = '</table></div><br><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;"><h3>'+@sistema+'</h3></strong></body></html>';

      select @mx_pg=100;

      select @id_ini=0, @id_fim=0, @id_atual=0;
      SELECT @id_ini=min(id_ref), @id_fim=max(id_ref) FROM tbUsuAlert

      select @id_atual=@id_ini;
      while(@id_atual>0 and @id_atual<=@id_fim) begin

         select @achou=0;
         SELECT @achou=1, @id_usuario_a=id_usuario, @nome_usu=nome_usu, @email=email, @alrtp_tipo_usu=alrtp_tipo_usu,
                @descricao=descricao, @tipo_reg=tipo_reg, @data_ocor=data_ocor, @depart=isnull(depart,''), @m_intjr=m_intjr, @m_atrasos=m_atrasos,
                @m_he_dia=m_he_dia, @m_he_lib=m_he_lib, @m_he_intervalo=m_he_intervalo, @m_faltas=m_faltas, @conta_intjr=conta_intjr,
                @conta_he_intervalo=conta_he_intervalo, @conta_faltas=conta_faltas, @alrtp_semana=alrtp_semana,
            @empresa=empresa, @id_empresa=id_empresa
         FROM tbUsuAlert WHERE id_ref=@id_atual;

         select @id_empresa_aux=@id_empresa;

         if @achou=1 and (
            (@alrtp_semana=@wdia and isnull(@id_usuario,0)=0) or
            (isnull(@id_usuario,0)=@id_usuario_a)
            )
         begin

            select @msg = '<html xmlns:v="urn:schemas-microsoft-com:vml" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:w="urn:schemas-microsoft-com:office:word" xmlns="http://www.w3.org/TR/REC-html40">'+CHAR(13)+CHAR(10)+'<head>';
            select @msg = @msg + '<meta name=Generator content="Microsoft Word 11 (filtered medium)">';
            select @msg = @msg + '<!--[if !mso]><style>v\:* {behavior:url(#default#VML);}o\:* {behavior:url(#default#VML);}w\:* {behavior:url(#default#VML);}.shape {behavior:url(#default#VML);}</style><![endif]-->';
            select @msg = @msg + CHAR(13)+CHAR(10)+'<title>'+@tit2+'</title></head>'+CHAR(13)+CHAR(10)+'<body>'+@stl;
            select @msg = @msg + '<div><span><br><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;"><h3>'+@tit2+'</h3></strong> ';
            select @msg = @msg + 'Perodo de apurao: ' + convert(varchar,@s_ini,103) + '  ' + convert(varchar,@s_fim,103) + '<br><br>';
            select @msg = @msg + 'Destinatrio: <strong style="font-family: Verdana,Arial,Helvetica,sans-serif;">'+@nome_usu+'</strong><br>';
            select @msg = @msg + 'Data de envio: '+convert(varchar,getdate(),103)+' '+convert(varchar,getdate(),108);
            select @msg = @msg + '<br><br></span></div>'+@leg;

            if @tipo_reg=0 begin

               select @conta_linha=0, @conta_pag=0;
               SELECT @conta_linha=count(*) FROM tbUsuAlert WHERE id_usuario=@id_usuario_a AND tipo_reg=0;
               select @conta_linha=isnull(@conta_linha,0);
               select @conta_pag=@conta_linha / @mx_pg;
               if @conta_pag*@mx_pg < @conta_linha begin
                  select @conta_pag=@conta_pag+1;
               end;

               select @linha_atu=1, @pag_atu=1;
               if @conta_pag>1
                  select @msg = replace(@msg,@tit2,@tit2+' email '+ltrim(str(@pag_atu,15,0))+' de '+ltrim(str(@conta_pag,15,0)));

               if @alrtp_tipo_usu<3
                  select @msg = @msg + '<div><span><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;">Empresa: </strong>'+@empresa+'</span></div>';

               select @msg = @msg + '<div><span><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;"><br>Ocorrncias:</strong></span></div>';
               select @msg = @msg + '<div><table width="800" class="stl" cellpadding="3" cellspacing="3">';
               if @alrtp_tipo_usu<3
                  select @msg = @msg + @cab1;
               else if @alrtp_tipo_usu=3
                  select @msg = @msg + @cab2;
               else
                  select @msg = @msg + @cab3;



               while (@pag_atu<=@conta_pag AND @linha_atu<=@conta_linha)
               begin

         if @alrtp_tipo_usu<3 and @id_empresa<>@id_empresa_aux
         begin
            select @id_empresa_aux=@id_empresa
            select @msg = @msg + '</table></div><br><br>'
            select @msg = @msg + '<div><span><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;">Empresa: </strong>'+@empresa+'</span></div>';
            select @msg = @msg + '<div><span><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;"><br>Ocorrncias: </strong></span></div>';
            select @msg = @msg + '<div><table width="800" class="stl" cellpadding="3" cellspacing="3">';
            select @msg = @msg + @cab1;
         end

                  --Detalhe

             if @alrtp_tipo_usu<3 begin

                select @msg = @msg + '<tr><td>'+left(ltrim(@depart),50)+'</td>';
                     select @msg = @msg + '<td>'+@descricao+'</td>';
                     select @msg = @msg + '<td>'+left(convert(varchar,@data_ocor,103),5)+'</td>';

            end   else
            begin
               select @msg = @msg + '<tr>';
               select @msg = @msg + '<td>'+@descricao+'</td>';
                  end;

                  if @he_dia=1 begin
                     exec P_CMTOH1 @m_he_dia, @marc output;
                     select @msg = @msg + '<td>'+@marc+'</td>';
                     if @tem_lib=1 begin
                        exec P_CMTOH1 @m_he_lib, @marc output;
                        select @msg = @msg + '<td>'+@marc+'</td>';
                     end;
                  end;
                  if @he_intervalo=1 begin
                     if @alrtp_tipo_usu<3 begin
                        exec P_CMTOH1 @m_he_intervalo, @marc output;
                        select @msg = @msg + '<td>'+@marc+'</td>';
                     end else begin
                        if @conta_he_intervalo>0
                           select @msg = @msg + '<td>'+ltrim(str(@conta_he_intervalo,38,00))+'</td>';
                        else
                           select @msg = @msg + '<td>-</td>';
                     end;
                  end;
                  if @falta_dia=1 begin
                     if @alrtp_tipo_usu<3 begin
                        exec P_CMTOH1 @m_faltas, @marc output;
                        select @msg = @msg + '<td>'+@marc+'</td>';
                     end else begin
                        if @conta_faltas>0
                           select @msg = @msg + '<td>'+ltrim(str(@conta_faltas,38,00))+'</td>';
                        else
                           select @msg = @msg + '<td>-</td>';
                     end;
                  end;
                  if @atraso_dia=1 begin
                     exec P_CMTOH1 @m_atrasos, @marc output;
                     select @msg = @msg + '<td>'+@marc+'</td>';
                  end;
                  if @interjor=1 begin
                     if @alrtp_tipo_usu<3 begin
                        exec P_CMTOH1 @m_intjr, @marc output;
                        select @msg = @msg + '<td>'+@marc+'</td>';
                     end else begin
                        if @conta_intjr>0
                           select @msg = @msg + '<td>'+ltrim(str(@conta_intjr,38,00))+'</td>';
                        else
                           select @msg = @msg + '<td>-</td>';
                     end;
                  end;

                  select @msg = @msg + '</tr>';


                  select @linha_atu=@linha_atu+1;
                  if @linha_atu<=@conta_linha AND ((@linha_atu-1)/@mx_pg)+1 > @pag_atu
                  begin
                     select @msg=@msg+'</table></div><br>Continua no prximo email....<br><br><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;"><h3>'+@sistema+'</h3></strong></body></html>';

                     select @c=@tit+' email ' + ltrim(str(@pag_atu,15,0))+' de '+ltrim(str(@conta_pag,15,0));
                     select @msg=replace(@msg,'<td>',CHAR(13)+CHAR(10)+'<td>');
                     select @msg=replace(@msg,'<tr>',CHAR(13)+CHAR(10)+'<tr>');
                     if len(isnull(@email,''))>5
                        EXEC PTO_ALERTA @email, @c, @msg

                     select @msg = ' ';
                     WaitFor Delay '00:00:01';

                     select @pag_atu=((@linha_atu-1)/@mx_pg)+1;

                     --Cabealho secundrio
                     select @msg = '<html xmlns:v="urn:schemas-microsoft-com:vml" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:w="urn:schemas-microsoft-com:office:word" xmlns="http://www.w3.org/TR/REC-html40">'+CHAR(13)+CHAR(10)+'<head>';
                     select @msg = @msg + '<meta name=Generator content="Microsoft Word 11 (filtered medium)">';
                     select @msg = @msg + '<!--[if !mso]><style>v\:* {behavior:url(#default#VML);}o\:* {behavior:url(#default#VML);}w\:* {behavior:url(#default#VML);}.shape {behavior:url(#default#VML);}</style><![endif]-->';
                     select @msg = @msg + CHAR(13)+CHAR(10)+'<title>'+@tit2+'</title></head>'+CHAR(13)+CHAR(10)+'<body>'+@stl;
                     select @msg = @msg + '<div><span><br><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;"><h3>'+@tit2+'</h3></strong><br><br></span></div>';
                     select @msg = @msg + '<div><span><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;">Continuao...</strong></span></div>';
                   if @alrtp_tipo_usu<3 begin
                  SELECT @empresa=isnull(empresa,''), @id_empresa=isnull(id_empresa,@id_empresa_aux) FROM tbUsuAlert WHERE id_ref=(@id_atual+1);
                        select @msg = @msg + '<div><span><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;">Empresa: </strong>'+@empresa+'</span></div>';
                  select @id_empresa_aux=@id_empresa;
                end;
                select @msg = @msg + '<div><table width="800" class="stl" cellpadding="3" cellspacing="3">';
                     select @msg = replace(@msg,@tit2,@tit2+' email '+ltrim(str(@pag_atu,15,0))+' de '+ltrim(str(@conta_pag,15,0)));
                     if @alrtp_tipo_usu<3
                        select @msg = @msg + @cab1;
                     else if @alrtp_tipo_usu=3
                        select @msg = @msg + @cab2;
                     else
                        select @msg = @msg + @cab3;

                  end else if @linha_atu>@conta_linha begin
                     select @msg=@msg+'</table></div><br>';
                  end;

                  select @achou=0;
                  select @id_atual=@id_atual+1;
                  SELECT @achou=1, @nome_usu=nome_usu, @email=email, @alrtp_tipo_usu=alrtp_tipo_usu,
                      @depart=isnull(depart,''),@descricao=descricao, @tipo_reg=tipo_reg, @data_ocor=data_ocor,  @m_intjr=m_intjr, @m_atrasos=m_atrasos,
                      @m_he_dia=m_he_dia, @m_he_lib=m_he_lib, @m_he_intervalo=m_he_intervalo, @m_faltas=m_faltas, @conta_intjr=conta_intjr,
                      @conta_he_intervalo=conta_he_intervalo, @conta_faltas=conta_faltas, @alrtp_semana=alrtp_semana,
                 @empresa=empresa, @id_empresa=id_empresa
                  FROM tbUsuAlert WHERE id_ref=@id_atual;
               end;

            end else begin
               select @msg = @msg + '<br>No h alertas de ponto no perodo.<br>';
            end;

            if @tipo_reg=1 begin
               select @msg = @msg + '<div><span><br><strong style="font-family: Verdana,Arial,Helvetica,sans-serif;">Totais:</strong></span></div>';
               select @msg = @msg + '<div><table width="800" class="stl" cellpadding="3" cellspacing="3">';
               if @alrtp_tipo_usu<3
                  select @msg = @msg + @cabt;
               else
                  select @msg = @msg + @cabt2;
               select @msg = @msg + '<tr>';
               if @he_dia=1 begin
                  exec P_CMTOH1 @m_he_dia, @marc output;
                  select @msg = @msg + '<td>'+@marc+'</td>';
                  if @tem_lib=1 begin
                     exec P_CMTOH1 @m_he_lib, @marc output;
                     select @msg = @msg + '<td>'+@marc+'</td>';
                  end;
               end;
               if @he_intervalo=1 begin
                  if @conta_he_intervalo>0
                     select @msg = @msg + '<td>'+ltrim(str(@conta_he_intervalo,38,00))+'</td>';
                  else
                     select @msg = @msg + '<td>-</td>';
               end;
               if @falta_dia=1 begin
                  if @conta_faltas>0
                     select @msg = @msg + '<td>'+ltrim(str(@conta_faltas,38,00))+'</td>';
                  else
                     select @msg = @msg + '<td>-</td>';
               end;
               if @atraso_dia=1 begin
                  exec P_CMTOH1 @m_atrasos, @marc output;
                  select @msg = @msg + '<td>'+@marc+'</td>';
               end;
               if @interjor=1 begin
                  if @conta_intjr>0
                     select @msg = @msg + '<td>'+ltrim(str(@conta_intjr,38,00))+'</td>';
                  else
                     select @msg = @msg + '<td>-</td>';
               end;
               select @msg = @msg + '</tr>';
               select @msg = @msg+@rdp;

               select @c=@tit+' email ' + ltrim(str(@pag_atu,15,0))+' de '+ltrim(str(@conta_pag,15,0));
               select @msg=replace(@msg,'<td>',CHAR(13)+CHAR(10)+'<td>');
               select @msg=replace(@msg,'<tr>',CHAR(13)+CHAR(10)+'<tr>');
               if len(isnull(@email,''))>5
                  EXEC PTO_ALERTA @email, @c, @msg
               select @msg = ' ';
               WaitFor Delay '00:00:01';
            end;

         end; --@achou=1 and ((@alrtp_semana=@wdia and isnull(@id_usuario,0)=0) or (isnull(@id_usuario,0)=@id_usuario_a))

         select @id_atual=@id_atual+1;
      end;

   end;

END;
GO

/* CRIAR/ATUALIZAR JOBS - INICIO */

declare @datcurrent nvarchar(128)
declare @comando varchar(128);

select @datcurrent=ltrim(DB_NAME());
select @comando=N'EXEC PROC_REAP_PTO 0';

IF  EXISTS (SELECT job_id FROM msdb.dbo.sysjobs_view WHERE name = N'pw_job_reapon')
BEGIN
   IF (left(@@Version,23)='Microsoft SQL Server 20' and left(@@Version,25)='Microsoft SQL Server 2000')
      EXEC msdb.dbo.sp_delete_job @job_name=N'pw_job_reapon', @delete_unused_schedule=1;
   else
      EXEC msdb.dbo.sp_delete_job @job_name=N'pw_job_reapon';
END;

BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
   EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
   IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'pw_job_reapon', @enabled=1, @notify_level_eventlog=0, @notify_level_email=0, @notify_level_netsend=0,
      @notify_level_page=0, @delete_level=0, @description=N'No description available.',  @category_name=N'[Uncategorized (Local)]', @owner_login_name=N'sa', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'principal', @step_id=1, @cmdexec_success_code=0, @on_success_action=1, @on_success_step_id=0,
      @on_fail_action=2, @on_fail_step_id=0, @retry_attempts=0, @retry_interval=0, @os_run_priority=0, @subsystem=N'TSQL',
      @command=@comando, @database_name=@datcurrent, @flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'schedule_reapon',
      @enabled=1, @freq_type=4, @freq_interval=1, @freq_subday_type=4, @freq_subday_interval=1,
      @freq_relative_interval=0, @freq_recurrence_factor=0, @active_start_date=20130101,
      @active_end_date=99991231, @active_start_time=13000, @active_end_time=223000
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

COMMIT TRANSACTION
IF (1>0) GOTO EndSave

QuitWithRollback:
   IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:
GO

EXEC('UPDATE tbParSist SET ult_reapon_status=0');
GO

declare @datcurrent nvarchar(128)
declare @comando varchar(128);

select @datcurrent=ltrim(DB_NAME());
select @comando=N'EXEC PROC_ALERTA_PTO 0';

IF  EXISTS (SELECT job_id FROM msdb.dbo.sysjobs_view WHERE name = N'pw_job_alertas')
BEGIN
   IF (left(@@Version,23)='Microsoft SQL Server 20' and left(@@Version,25)='Microsoft SQL Server 2000')
      EXEC msdb.dbo.sp_delete_job @job_name=N'pw_job_alertas', @delete_unused_schedule=1;
   else
      EXEC msdb.dbo.sp_delete_job @job_name=N'pw_job_alertas'
END;

BEGIN TRANSACTION
DECLARE @ReturnCode INT

SELECT @ReturnCode = 0

IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
   EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
   IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback2
END

DECLARE @jobId BINARY(16)
select @jobId=null;
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'pw_job_alertas', @enabled=1, @notify_level_eventlog=0, @notify_level_email=0, @notify_level_netsend=0,
      @notify_level_page=0, @delete_level=0, @description=N'No description available.',  @category_name=N'[Uncategorized (Local)]', @owner_login_name=N'sa', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback2

EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'principal', @step_id=1, @cmdexec_success_code=0, @on_success_action=1, @on_success_step_id=0,
      @on_fail_action=2, @on_fail_step_id=0, @retry_attempts=0, @retry_interval=0, @os_run_priority=0, @subsystem=N'TSQL',
      @command=@comando, @database_name=@datcurrent, @flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback2

EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback2

EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'manha',
      @enabled=1, @freq_type=4, @freq_interval=1, @freq_subday_type=1, @freq_subday_interval=0,
      @freq_relative_interval=0, @freq_recurrence_factor=0,
      @active_start_date=20110701, @active_end_date=99991231,
      @active_start_time=100000, @active_end_time=235959
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback2

EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback2

COMMIT TRANSACTION
IF (1>0) GOTO EndSave2

QuitWithRollback2:
   IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave2:
GO
/* CRIAR/ATUALIZAR JOBS - FIM */

